#include <cstdio>
#include <cmath>
#include <map>
#include <vector>
using namespace std;
#define PI 3.141592653589793238462643383279

struct point{
	int x, y, z;
};

struct seg {
	point p1, p2;
	bool operator () (const point &p1, const point &p2){
		if(p1.x != p2.x)
			return p1.x<p2.x;
		if(p1.y != p2.y)
			return p1.y<p2.y;
		if(p1.z != p2.z)
			return p1.z<p2.z;
		return true;
	}
};

struct comparer {
public:
	bool operator () (const point &p1, const point &p2){
		if(p1.x != p2.x)
			return p1.x<p2.x;
		if(p1.y != p2.y)
			return p1.y<p2.y;
		if(p1.z != p2.z)
			return p1.z<p2.z;
		return true;
	}

};

point vec(seg s){
	point v;
	v.x = s.p2.x-s.p1.x;
	v.y = s.p2.y-s.p1.y;
	v.z = s.p2.z-s.p1.z;
	return v;
}

double len(seg s){
	double x = s.p1.x-s.p2.x;
	double y = s.p1.y-s.p2.y;
	double z = s.p1.z-s.p2.z;
	return sqrt(x*x+y*y+z*z);
}

double deg(seg s1, seg s2){
	point v1, v2;
	v1 = vec(s1);
	v2 = vec(s2);
	double d = ((double)(v1.x*v2.x + v1.y*v2.y + v1.z*v2.z)) / ((double) (len(s1) * len(s2)));
	return acos(d) * 180 / PI;
}

int eq(point p1, point p2){
	return p1.x == p2.x && p1.y == p2.y && p1.z == p2.z;
}

point mp(int x, int y, int z){
	point p;
	p.x = x;
	p.y = y;
	p.z = z;
	return p;
}

point pairpoint(pair<pair<int,int>, int> pp){
	return mp(pp.first.first, pp.first.second, pp.second);
}

pair<pair<int,int>,int> pointpair(point p){
	return make_pair(make_pair(p.x,p.y),p.z);
}

int cmp(point p1, point p2){
	if(p1.x != p2.x)
		return p1.x-p2.x;
	if(p1.y != p2.y)
		return p1.y-p2.y;
	if(p1.z != p2.z)
		return p1.z-p2.z;
	return 0;
}

void print(point p){
	printf("%d %d %d\n", p.x, p.y, p.z);
}

int main(){
	//printf("%d", eval)
	int N, S, T;
	while(scanf("%d %d %d", &N, &S, &T) == 3){
		point start, end;
		scanf("%d %d %d %d %d %d", &start.x, &start.y, &start.z, &end.x, &end.y, &end.z);
		vector< seg > segs;
		vector< seg > sorted;
		map< pair<pair<int,int>,int>, vector<int> > beg;
		int poc = 0;
		for(int i=0; i<N; i++){
			seg s;
			point p1, p2;
			pair<pair<int,int>,int> pp1 = pointpair(p1);
			pair<pair<int,int>,int> pp2 = pointpair(p2);
			scanf("%d %d %d %d %d %d", &p1.x, &p1.y, &p1.z, &p2.x, &p2.y, &p2.z);
			if(beg.find(pp1) == beg.end())
				beg[pp1] = vector<int>(0);
			if(beg.find(pp2) == beg.end())
				beg[pp2] = vector<int>(0);
			s.p1 = p1;
			s.p2 = p2;
			segs.push_back(s);
			beg[pp1].push_back(poc++);
			printf("a%da", beg[pp1].size());
			print(s.p1); print(s.p2);
			s.p1 = p2;
			s.p2 = p1;
			segs.push_back(s);
			beg[pp2].push_back(poc++);
			printf("a%da", beg[pp2].size());
			print(s.p1); print(s.p2);
		}
		printf("[%d]", poc);
		point p = start;
		int qq = 0;
		seg cur, last;
		bool ss = true;
		while(!eq(p,end) && qq < N){
			printf("from %d %d %d\n", p.x, p.y, p.z);
			pair<pair<int,int>,int> pp = pointpair(p);
			vector<int> v = beg[pp];
			printf("(%d) ", v.size());
			for(int k=0; k<v.size(); k++){
				cur = segs[v[k]];
				if(!ss && !eq(last.p1, cur.p2))
					break;
			}
			sorted.push_back(cur);
			p = cur.p2;
			printf("to %d %d %d\n", p.x, p.y, p.z);
			++qq;
			ss = false;
			last = cur;
		}
		double L = 0, D = 0;
		for(int i=0; i<N; i++){
			L += len(sorted[i]);
			if(i > 0){
				D += deg(sorted[i-1], sorted[i]);
			}
		}
		double R = L/S + D/T;
		printf("%f\n", R);
	}
	return 0;
}
